#include <iostream>
#include <sl/class_loader.hpp>

#include "modules/target.h"

int main()
{
    try {
        sl::class_loader l1("/modules/target.so"); // error
        l1.instance<modules::target>();
        std::clog << "1 OK" << std::endl;
    } catch (std::runtime_error& e) { std::cerr << e.what() << std::endl; }

    try {
        sl::class_loader l2("/modules/target");
        l2.instance<modules::target>();
        std::clog << "2 OK" << std::endl;
    } catch (std::runtime_error& e) { std::cerr << e.what() << std::endl; }

    try {
        sl::class_loader l3("./modules/target.so");
        modules::target* p = l3.instance<modules::target>();
        std::clog << "3 OK" << std::endl;
    } catch (std::runtime_error& e) { std::cerr << e.what() << std::endl; }

    try {
        sl::class_loader l4("./modules/target");
        l4.instance<modules::target>();
        std::clog << "4 OK" << std::endl;
    } catch (std::runtime_error& e) { std::cerr << e.what() << std::endl; }

    try {
        sl::class_loader l5("modules/target.so");
        l5.instance<modules::target>();
        std::clog << "5 OK" << std::endl;
    } catch (std::runtime_error& e) { std::cerr << e.what() << std::endl; }

    try {
        sl::class_loader l6("modules/target");
        l6.instance<modules::target>();
        std::clog << "6 OK" << std::endl;
    } catch (std::runtime_error& e) { std::cerr << e.what() << std::endl; }

    try {
        sl::class_loader l7("modules.target");
        l7.instance<modules::target>();
        std::clog << "7 OK" << std::endl;
    } catch (std::runtime_error& e) { std::cerr << e.what() << std::endl; }

    try {
        sl::class_loader l8(".modules.target");
        l8.instance<modules::target>();
        std::clog << "8 OK" << std::endl;
    } catch (std::runtime_error& e) { std::cerr << e.what() << std::endl; }

    try {
        sl::class_loader l9("modules.target.so"); // error
        l9.instance<modules::target>();
        std::clog << "9 OK" << std::endl;
    } catch (std::runtime_error& e) { std::cerr << e.what() << std::endl; }

    return 0;
}
