/*-
 * Copyright (c) 2005 masashi osakabe
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#ifndef SJ_ENGINE_EXPRESSION_EVALUATOR_IMPL_H
#define SJ_ENGINE_EXPRESSION_EVALUATOR_IMPL_H

#include <servlet/jsp/PageContext.h>
#include <servlet/jsp/el/ExpressionEvaluator.h>

namespace sj {

class ExpressionEvaluatorImpl : public servlet::jsp::el::ExpressionEvaluator {
public :
    ExpressionEvaluatorImpl(servlet::jsp::PageContext& context);
    virtual ~ExpressionEvaluatorImpl();

    virtual
    sl::java::lang::Object evaluate(const std::string& expression,
                        const sl::java::lang::Class& type,
                        const servlet::jsp::el::VariableResolver& resolver,
                        const servlet::jsp::el::FunctionMapper& mapper)
        throw (servlet::jsp::el::ELException);

    virtual std::auto_ptr<servlet::jsp::el::Expression>
    parseExpression(const std::string& expression,
                        const sl::java::lang::Class& type,
                        const servlet::jsp::el::FunctionMapper& mapper)
        throw (servlet::jsp::el::ELParseException);

private :
    servlet::jsp::PageContext& _context;
};

} // namespace sj

#endif // SJ_ENGINE_EXPRESSION_EVALUATOR_IMPL_H
