/*-
 * Copyright (c) 2005 masashi osakabe
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#ifndef SERVLET_SERVLET_REQUEST_LISTENER_H
#define SERVLET_SERVLET_REQUEST_LISTENER_H

#include <sl/java/util/EventListener.h>
#include <servlet/ServletRequestEvent.h>

namespace servlet {

/**
 * @interface.
 *
 * 饤ȤΥꥯȤμȼ @c ServletRequest 
 * ٥ȤˤΤȤƼդ٤Υ󥿡եޤ.
 *
 * ꥹʡΥɤ Servlet ƥʤεưˤΤ߹Ԥʤ졢
 * Web ץꥱһҤξ˽äƹԤʤޤ.
 */
class ServletRequestListener : public sl::java::util::EventListener {
public :
    /** Destructor. */
    virtual ~ServletRequestListener() { }

    /**
     * ServletRequest λǸƤӽФؿǤ.
     *
     * ºݤ requestInitialized дؿ¹ԤΤ
     * 饤ȤΥꥯȼľǤϤʤ
     * Servlet ƥǤΥꥯȤθڽǧڽ򽪤
     * Filter::doFilter  Servlet::service μ¹ľȤʤޤ.
     *
     * @param    e    @c ServletContext   @c ServletRequest ݻ
     *                @c ServletRequestEvent 󥹥󥹤ؤλ.
     */
    virtual void requestInitialized(ServletRequestEvent& e)=0;

    /**
     * ServletRequest κλǸƤӽФؿǤ.
     *
     * ºݤ requestDestroyed дؿ¹ԤΤ
     * Filter::doFilter  Servlet::service μ¹ԽλľǤϤʤ
     * 饤ȤΥ쥹ݥ󥹤ν񤭹ߤ䤽¾Υ꡼󥢥å׽
     * λƤȤʤޤ.
     *
     * @param    e    @c ServletContext   @c ServletRequest ݻ
     *                @c ServletRequestEvent 󥹥󥹤ؤλ.
     */
    virtual void requestDestroyed(ServletRequestEvent& e)=0;
};

} // namespace servlet

#endif // SERVLET_SERVLET_REQUEST_LISTENER_H
