/*-
 * Copyright (c) 2005 masashi osakabe
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#ifndef SERVLET_JSP_TAGEXT_TAG_H
#define SERVLET_JSP_TAGEXT_TAG_H

#include <servlet/jsp/PageContext.h>
#include <servlet/jsp/tagext/JspTag.h>
#include <servlet/jsp/JspException.h>

namespace servlet {
namespace jsp {
namespace tagext {

class Tag : public JspTag {
public :
    enum {
        /** ¸ߤϥȥ꡼̤ƥܥǥɾޤ */
        EVAL_BODY_INCLUDE    = 0x01,

        /** ڡɾ³ޤ */
        EVAL_PAGE            = 0x02,

          /** ܥǥɾ򥹥åפޤ */
        SKIP_BODY            = 0x03,

         /** ڡλĤʬ򥹥åפޤ */
        SKIP_PAGE            = 0x04
    };

    Tag() { }

    virtual ~Tag() { }

    /** Υ󥹥󥹤γϥޤ */
    virtual int doStartTag() throw(JspException)=0;

    /** Υ󥹥󥹤νλޤ */
    virtual int doEndTag() throw(JspException)=0;

    /** Υϥɥο(Ǥ᤯Ϥॿϥɥ)ޤ */  
    virtual Tag& getParent()=0;

    /** ֤뤿TagϥɥǸƤФޤ. */
    virtual void release()=0;

    /** ߤΥڡƥȤꤷޤ. */
    virtual void setPageContext(PageContext& pc)=0;

    /** Υϥɥο(Ǥ᤯Ϥॿϥɥ)ꤷޤ. */
    virtual void setParent(Tag& t)=0;
};

} // namespace tagext
} // namespace jsp
} // namespace servlet

#endif // SERVLET_JSP_TAGEXT_TAG_H
