/*-
 * Copyright (c) 2005 masashi osakabe
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: RequestValidateValve.cpp,v 1.7 2008/05/06 16:26:11 cvsuser Exp $
 */

#include <si/interface/Connection.h>
#include <si/interface/Request.h>
#include <si/interface/Response.h>
#include <si/interface/ValveContext.h>
#include <si/core/ErrorPage.h>

#include "RequestValidateValve.h"
using namespace modules::valve;


//
// Constructor/Destructor
//

RequestValidateValve::RequestValidateValve()
{ }

RequestValidateValve::~RequestValidateValve()
{ }

void RequestValidateValve::config(const si::interface::Config& c)
{
	_config = c;
}

si::interface::Config RequestValidateValve::config() const
{
	return _config;
}

void RequestValidateValve::invoke(si::interface::Connection& p,
                                  si::interface::ValveContext& context)
{
	si::interface::Request& req  = p.request();
	si::interface::Response& res = p.response();

	if (req.getProtocol() == "HTTP/1.1" && req.getHeader("Host").empty()) {
		res.sendError(400);
		return;
	}

	context.invokeNext(p);
}
